//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
//----------------------------------------------------------------------------//
#pragma package(smart_init)
#pragma resource "*.dfm"

// source tested by dllee<dllee@edirect168.com> http://dllee.ktop.com.tw
// NHUoѰ remark iH LOG X Hook ȡAbO Hook 
// #define _LOGHOOK_

TForm1 *Form1;
HHOOK hKeyHook,hMouseHook;
//----------------------------------------------------------------------------//
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
#ifdef _LOGHOOK_
  this->Label1->Caption="Hook Log";
  this->Label2->Caption="Hook Log";
#else
  this->Label1->Caption="No Hook Log";
  this->Label2->Caption="NO Hook Log";
  this->Label1->Enabled=false;
  this->Label2->Enabled=false;
#endif

  this->CheckBox1->Checked=true;
  hKeyHook=0;
  hMouseHook=0;
  Button2Click(NULL);
}
//----------------------------------------------------------------------------//
__fastcall TForm1::~TForm1()
{
  Button2Click(NULL);
}
//----------------------------------------------------------------------------//
LRESULT CALLBACK KeyHook(int iCode, WPARAM wParam, LPARAM lParam)
{
#ifdef _LOGHOOK_
    Form1->Label1->Caption="Code="+IntToHex(iCode,8)
                        +"\nwParam="+IntToHex(int(wParam),8)
                        +"\nlParam="+IntToHex(int(lParam),8);
#endif

  if(iCode < 0)
    CallNextHookEx(hKeyHook, iCode, wParam, lParam);
  return 1;
}
//----------------------------------------------------------------------------//
LRESULT CALLBACK MouseHook(int iCode, WPARAM wParam, LPARAM lParam)
{
#ifdef _LOGHOOK_
    Form1->Label2->Caption="Code="+IntToHex(iCode,8)
                        +"\nwParam="+IntToHex(int(wParam),8)
                        +"\nlParam="+IntToHex(int(lParam),8);
#endif

  if(iCode < 0)
    CallNextHookEx(hMouseHook, iCode, wParam, lParam);
  return 1;
}
//----------------------------------------------------------------------------//
// Install hook
void __fastcall TForm1::Button1Click(TObject *Sender)
{
  if(this->CheckBox1->Checked)
  {                                         // Install key hook
    hKeyHook=SetWindowsHookEx(WH_KEYBOARD,(HOOKPROC)KeyHook,HInstance,0);
    if(hKeyHook==NULL)
      ShowMessage("Fail to Hook Keyboard!");
  }
  if(this->CheckBox2->Checked)
  {                                         // Install mouse hook
    hMouseHook=SetWindowsHookEx(WH_MOUSE,(HOOKPROC)MouseHook,HInstance,0);
    if(hMouseHook==NULL)
      ShowMessage("Fail to Hook Mouse!");
  }
  this->Button1->Enabled=false;
  this->Button2->Enabled=true;
}
//----------------------------------------------------------------------------//
// Uninstall hook
void __fastcall TForm1::Button2Click(TObject *Sender)
{
  if(hKeyHook!=0)
  {
    UnhookWindowsHookEx(hKeyHook);          // Uninstall key hook
    hKeyHook=0;
  }
  if(hMouseHook!=0)
  {
    UnhookWindowsHookEx(hMouseHook);        // Uninstall mouse hook
    hMouseHook=0;
  }
  this->Button1->Enabled=true;
  this->Button2->Enabled=false;
}
//----------------------------------------------------------------------------//

